import { AfterContentChecked, AfterViewInit, ChangeDetectorRef, EventEmitter, OnChanges, OnDestroy, OnInit, QueryList, SimpleChanges, TemplateRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Option } from '../../models/option';
import { OptionComponent } from '../option/option.component';
import { SelectSource } from '../../stores/select-source';
import { OptionsComponent } from '../options/options.component';
export interface SelectOptions {
    theme?: string;
    search?: boolean;
    searchDebounce?: number;
    searchMinimumLength?: number;
    optionsFitInput?: boolean;
    valueEquals?: (lhs: any, rhs: any) => boolean;
    labels?: {
        loading?: string;
        notFound?: string;
        searchPlaceholder?: string;
        searchShouldBeLonger?: string;
    };
    classes?: string[];
}
export declare const DefaultSelectOptions: SelectOptions;
export declare class SelectComponent implements OnInit, OnDestroy, OnChanges, AfterViewInit, AfterContentChecked, ControlValueAccessor {
    private cd;
    options: SelectOptions;
    initialValue: any;
    source: SelectSource;
    placeholder: string;
    disabled: boolean;
    inputTemplate: TemplateRef<any>;
    optionTemplate: TemplateRef<any>;
    change: EventEmitter<any>;
    loadedInitialValue: EventEmitter<void>;
    optionsComponent: OptionsComponent;
    staticOptions: QueryList<OptionComponent>;
    viewInitialized: boolean;
    loading: boolean;
    classes: any[];
    private value;
    private valueInitialSet;
    private valueOption;
    private touchCallback;
    private changeCallback;
    constructor(cd: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    ngAfterContentChecked(): void;
    readonly currentOptions: SelectOptions;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    setValue(value: any): void;
    onOptionSelected(option: Option): void;
    readonly selectedOption: Option;
    toggleOpened(): void;
    stopEvent(e: any): void;
    onBlur(): void;
    onTouched(): void;
    updateClasses(): void;
    templateContext(option: Option): {
        value: any;
        name: string;
        image: string;
        data: any;
    };
}
